//--------------------------- tco ------------------------------
final int CURSEUR        = 15;                //  dimension du curseur dans les ascenseurs H et V

int       MAILLE         = 10;                //  maille de la grille
float     RAIL           = 2F;                //  largeur des rails dans un pave
float     DIAG_RAIL      = RAIL/sqrt(2F)/2F;  //  demie diagonale de RAIL/2
int       BORDURE_X      = 10;
int       BORDURE_Y      = 10;
int       C_MAX          = 188;               //  nombre de colonnes maxi
int       L_MAX          = 104;               //  nombre de lignes maxi
int       ZOOM_INIT      = 8;                 //  zoom au demarrage

float     RETRAIT        = 1;                 //  largeur d'un 1/2 retrait 
float     DIAG_RETRAIT   = RETRAIT/sqrt(2F);  //  diagonale de RETRAIT
float     TAILLE_FEU     = MAILLE/6F;         //  taille du feu

float     EPAISSEUR_MAT  = 0.4F;              //  epaisseur du mat de la cible
float     LONGUEUR_MINI  = 5F*MAILLE;         //  longueur mini pour qu'une zone ait des signaux
float     PAS            = 0.1F;              //  "pas" entre deux points

int       INDEX_MAX      = 400;               //  nombre maximum de paves dans un itinéraire
int       MAX_A_B        = 40;                //  nombre maximum d'itinéraires pour A et B donnes

int       C_MAX_P        = 20;                //  nombre maximal de pupitres
int       C_MAX_T        = 30;                //  nombre maximal de trains
int       ECART          = int(2/PAS);        //  ecart entre deux wagons (20)
//------------------------ clignotements --------------------
long      oldTimeFeux;
long      newTimeFeux;
boolean   cliFeux;                            // pour clignotement feux
long      oldTimeItis;
long      newTimeItis;
boolean   cliItis;                            // pour flash itinéraires
long      oldTime;
long      newTime;
//----------------------- load/save --------------
String    file_selected;
String    date;

TCO            tco;
Palette        palette;
Pave           pave;
Pave           paveCL;
Pave           pave_CL;
Pave           pave_1;
Pave           pave_2;
Pave           pavePont;
Pave           pave_selectionne;
Pave           pave_feu_noir;
Pave           premier_pave;
Pupitre        pupitre;

Itineraire     itineraire;
Itineraire     dernier_itineraire;
Train          train;
Train          train_courant;
Train          train_trouve;
Zone           zone;

Point          point;
Point          points_iti;
Vehicule       vehicule;
Vehicule       vehiculecopy;

ArrayList<Pave>       tous_paves     = new ArrayList<Pave>();                                                                                        //  liste de tous les paves, sur les 2 niveaux
ArrayList<Pave>       tous_signaux   = new ArrayList<Pave>();                                                                                        //  liste de tous les pavé avec signal, sur les 2 niveaux
ArrayList<Itineraire> tous_iti_tempo = new ArrayList<Itineraire>();                                                                                  //  liste de tous les itinéraires trouves                    
ArrayList<Itineraire> tous_iti       = new ArrayList<Itineraire>();                                                                                  //  liste de tous les itinéraires                 
ArrayList<Zone>       toutes_zones   = new ArrayList<Zone>();                                                                                        //  liste de toutes les zones
ArrayList<String>     tous_ID_zone   = new ArrayList<String>();                                                                                      //  liste de tous les ID_zone
ArrayList<Vehicule>   tous_vehicules = new ArrayList<Vehicule>();                                                                                    //  liste de tous les véhicules
IntList               liste_trains   = new IntList();                                                                                                //  liste de tous les numéros de pupitre affectés aux trains (T -> P)
//---------------------------------------------- couleurs ------------------------------
int       GRIS       = #808080;
int       ROUGE      = #FF0000;
int       GRIS_FONCE = #B5B5B5;
int       BLANC      = #FFFFFF;
int       JAUNE      = #faca30;//#ffb200;//#FFFF00;
int       VERT       = #00FF00;
int       VIOLET     = #9370DB;
int       VERT_FONCE = #008000;
int       ARDOISE    = #5A5E6B;
int       BLEU       = #0000FF;
int       BLEU1      = #C8E8E8;
int       BLEU2      = #9AB3B3;
int       FOSSE      = #6E696A;
int       PONT       = #A6A6A6;
int       FOND       = #D4D4D4;
int       NOIR       = #000000;
int       AQUA       = #00FFFF;
int       OR         = #FFD900;
int       OLIVE      = #556B2F;
int       SABLE      = #F4A460;
int       POURPRE    = #BA55D3;
int       VERT_FLUO  = #7CFC00;
int       VERT6019   = #b9ceac;
int       VERT6027   = #7ebab5;
int       FOND_TRAIN = #454545;
int       FOND_VIDE  = #C5C7C4;
////////////////////////////////////////////////////////////////////////////////////////////////////
//--------------------------- TCO ------------------------------
int       c_max               = C_MAX;
int       l_max               = L_MAX;    
int       zoom_x              = ZOOM_INIT;
int       zoom_y              = ZOOM_INIT;
boolean   one_shot            = true;
int       numero_pupitre      = 0;   
float     c_min               = 0F;      //  draw from colonne c_min
float     l_min               = 0F;      //  draw from ligne l_min
float     zoom_change         = 0;      //  zoom change when mousewheel or +/-
int       niveau              = 1;      //  niveau of the layout
int       width_precedent     = 0;
int       compte              = 0;
//------------------------- variables spéciales palette -------------------
int       zoom_palette        = 0;
int       x_palette           = 0;
int       y_palette           = 0;
//-------------------------- positions ----------------------------------
int       bordure_x           = 0;      //  bordure out of the grid of the TCO in x
int       bordure_y           = 0;      //  bordure out of the grid of the TCO in y
int       xOffset             = 0;      //  
int       yOffset             = 0;
int       x_precedent         = 0;
int       y_precedent         = 0;
int       x_mouse             = 0;
int       y_mouse             = 0;
int       c_mouse             = 0;
int       l_mouse             = 0;
int       c_info_pave         = 0;
int       l_info_pave         = 0;
float     X_m                 = 0F;
float     Y_m                 = 0F;
int       c_depart            = 0;
int       l_depart            = 0;
int       c_arrivee           = 0;
int       l_arrivee           = 0;
int       c_retour            = 0;
int       l_retour            = 0;
int       c_autre             = 0;
int       l_autre             = 0;
boolean   trouve              = false;
int       c_trouve            = 0;
int       l_trouve            = 0;
int       cote_1              = 0;
int       cote_2              = 0;
PVector   depart, arrivee, connecteur_courant, autre, connecteur_retour;
//--------------------- pupitre ------------------
int       x_pupitre           = 0;      //  position x of the pupitre
int       y_pupitre           = 0;      //  position y of the pupitre
int       x_mouse_p           = 0;      //  position x of the mouse in the pupitre
int       y_mouse_p           = 0;      //  position y of the mouse in the pupitre
int       x_offset_p          = 0;      //  decalage de la position X de la souris quand on prend la pupitre
int       y_offset_p          = 0;      //  decalage de la position Y de la souris quand on prend la pupitre
String    numero_de_zone      = "";     //  numero de la zone survolee par la souris
String    names[]             = {"Nf"};

float     largeur_tuile       = 0F;
float     hauteur_tuile       = 0F;
float     largeur_vehicule    = 0;
float     longueur_vehicule   = 0;
//-------------------- booleans for keys -----------------------
boolean   affiche_grille      = true;   //  Key 'g'    = affiche la grille ou pas
boolean   affiche_coordonnees = false;  //  Key 'G'    = avec les coordonnées
boolean   affiche_pupitre     = true;   //  Key 'p'    = pupitre or not
boolean   mode_selection      = false;  //  Key 'CTRL' = start/stop the select mode
boolean   deplacement         = false;  //  Key 'x'    = cut the paves for mouving
boolean   zone_locked         = false;  //  Key 'z'    = Memorization of the corresponding # for elements (blocks, turnouts, ...) 
boolean   display_locked      = false;  //  Key 'd'    = Display the corresponding # for elements (blocks, turnouts, ...)
boolean   undo_locked         = false;  //  Key 'u'    = Undo copying, cutting or erasing
boolean   nettoyage           = false;  //  Key 'e'    = efface la zone selectionnee
boolean   nettoyage_effectue  = false;
boolean   etiquettes_pont     = false;  //  Key 'D'    = Display labels of the Ponts trackpp. They are different from elements's labels.
boolean   mode_flexible       = false;  //  Flex_track_mode
boolean   deplacement_pupitre = false;  //  deplace le pupitre
boolean   itineraire_demande  = false;  //  Key 'i'    = demande d'itinéraire
boolean   montre_itineraires  = false;  //  Key 'm'    = montrer tous les itinéraires
int       position_bouton     = 0;
boolean   aide                = false;
boolean   sauvegarde          = false;
boolean   affiche_numero_zone = false;
boolean   sauve               = false;
boolean   zone_recherchee     = false;
boolean   affiche_pupite      = true;
boolean   iti_tempo           = false;
boolean   feu_noir            = false;
int       cote_feu_noir       = -1;
int       c_boucle            = 0;
int       l_boucle            = 0;
boolean   iti_cycle           = false;
boolean   affiche_points      = false;
boolean   tables_construites  = false;
boolean   recopie_en_cours    = false;
int       numero_point_train  = -1;
boolean   affiche_trains      = false;
int       choix_train         = -1;
boolean   affiche_train_sauve_initial = false;
boolean   affiche_exit        = true;
boolean   supprime_train      = false;
int       numero_attelage     = 0;
boolean   demande_double_clic = false;
int       nb_pupitres         = 0;
int       num_train_pupitre   = 0;
boolean   supp_en_cours       = false;
int       memo_numero2        = 0;
int       memo_case           = 0;
//------------------------------ background -----------------------
PImage    fond_pave;                    //  200x200
PImage    fond_bouton[]       = new PImage[30];                  //  200x200
PImage    fond_menu;                    //  200x200
PImage    ombre_bouton[]      = new PImage[30];
int       largeur_fond_pave   = 200;
int       hauteur_fond_pave   = 200;
PImage    curseur_depart;
PImage    curseur_arrivee;
PImage    curseur_montre_itineraires;
PImage    curseur_loco;
PImage    curseur_iti;
PImage    curseur_cycle;
PImage    curseur_horloge;
PImage    fond_pupitre;
PImage    fond_pupitre_horloge;
PImage    fond_pupitre_train;
int       largeur_fond_pupitre = 200;
int       hauteur_fond_pupitre = 200;
PImage    image_curseur[]      = new PImage[C_MAX_P];
String    texte_affiche        = ".";
String    texte_affiche_train  = ".";
int       couleur_affichee     = BLANC;
int       couleur_affiche_train= BLANC;
String    texte1               = "";
int       couleur1             = 0;
PImage    ecran;
PImage    ecran_itis;
boolean   affiche_ecran        = false;
PImage    fond_ecran;
PImage    image_vehicule[]     = new PImage[20];
PImage    fond_affiche_trains;
//--------------------------------- Pont tournant --------------------------------------------
int[]     Pont                = new int[162];          //  Pont
float     theta               = 0F;
int       max_ordre           = 0;
float     c0_pont             = 0F;
float     l0_pont             = 0F;
int       c_pont              = 0;
int       l_pont              = 0;
boolean   pont_tournant_pose          = false;
boolean   voie_pont_tournant_pose     = false;
int       Pont_track_count    = 0;
boolean   voie_pont_droite = false;
Table     TCO;
Table     Materiel;
//-------------------------------- recherche d'un itinéraire ------------------------------------
int       index               = 0;
int       iti[][]             = new int[INDEX_MAX][6];    //  INDEX_MAX lignes et c, l, rang (0, 1, 2), lames (0, 1, 2, 3), multi de premier (1, 2, 3) & cote entrée (0, 1)
PVector   premier[]           = new PVector[INDEX_MAX];
PVector   sortie              = new PVector();
boolean   retour              = false;
boolean   fini                = false;
int       courant             = 0;
int       numero_iti          = -1;
int       numero_iti_debut    = -1;
boolean   tout_teste          = false;
boolean   cherche_arrivee     = false;
int       max_index           = 0;
int       max_recherche       = 0;
//--------------------------------- signaux ----------------------------------------------------
String    zone_courante       = "-";
int       connecteur_futur    = 0;
int       vitesse_maxi        = 0;
//--------------------------------- images -------------------------
PImage    texte_aide, curseur;
int       largeur_texte       = 0;
int       hauteur_texte       = 0;
//**************************** curseur ********************************
float     largeur_pixel       = 1.0;
float     hauteur_pixel       = 1.0;
float     hauteur_bouton      = 0.0;
float     curseur_up          = 1.5;
float     curseur_down        = 4;                                //2.5*(10*hue/30)/333+1.5;
int       ordre               = 0;
String    texte;
int       vitesse[]           = new int[C_MAX_P];
int       hauteur_curseur[]   = new int[C_MAX_P];
int       consigne_train[]    = new int[C_MAX_P];
int       duree_restante[]    = new int[C_MAX_P];
int       max_duree[]         = new int[C_MAX_P];
//-------------------------- feux ------------------------------
final int ETEINT                    = 0;
final int VOIE_LIBRE                = 1;
final int AVERTISSEMENT             = 2;
final int SEMAPHORE                 = 3;
final int SEMAPHORE_CLI             = 4;
final int CARRE                     = 5;
final int MANOEUVRE                 = 6;
final int CARRE_VIOLET              = 7;
final int RALENTISSEMENT            = 8;
final int RALENTISSEMENT_CLI        = 9;
final int RAPPEL_RALENTISSEMENT     = 10;
final int RAPPEL_RALENTISSEMENT_CLI = 11;
final int COMBINE                   = 12;
final int COMBINE_CLI               = 13;
final int BUTOIR                    = 14;
final int DISQUE                    = 15;
PFont fontMessage;
PFont fontUnits;                // font pour les unites sur le cadran
//------------------ charge_images() ------------------------
void charge_images() {
    fond_ecran                          = loadImage("data/Icones/Fond ecran.png");
    fond_bouton[0]                      = loadImage("data/Icones/Zoom plus.png");
    ombre_bouton[0]                     = loadImage("data/Icones/Zoom inverse.png");
    fond_bouton[1]                      = loadImage("data/Icones/Zoom moins.png");
    ombre_bouton[1]                     = loadImage("data/Icones/Zoom inverse.png");
    fond_bouton[2]                      = loadImage("data/Icones/Itineraire.png");
    ombre_bouton[2]                     = loadImage("data/Icones/Itineraire inverse.png");
    fond_bouton[3]                      = loadImage("data/Icones/Cycle.png");
    ombre_bouton[3]                     = loadImage("data/Icones/Cycle inverse.png");
    fond_bouton[4]                      = loadImage("data/Icones/Cree train.png");
    ombre_bouton[4]                     = loadImage("data/Icones/Cree train inverse.png");
    fond_bouton[5]                      = loadImage("data/Icones/Aide.png");
    ombre_bouton[5]                     = loadImage("data/Icones/Aide inverse.png");
    //------------------------ Images --------------------------------------------------
    fond_pave                           = loadImage("data/Icones/Carre.png");
    curseur_iti                         = loadImage("data/Icones/Curseur_iti.png");
    curseur_cycle                       = loadImage("data/Icones/Curseur_cycle.png");
    curseur_horloge                     = loadImage("data/Icones/Curseur_horloge.png");
    for (int i = 0; i < C_MAX_P; i++) {
        image_curseur[i]                = loadImage("data/Icones/Curseur.png");
    }
    fond_pupitre                        = loadImage("data/Icones/FondPupitre.png");
    fond_pupitre_horloge                = loadImage("data/Icones/FondPupitreHorloge.png");
    fond_affiche_trains                 = loadImage("data/Icones/Train4.png");
}
//--------------------------- left points -----------------------
float     X1_x   = 0F;
float     X1_y   = 0F;
float     X3_x   = 0F;
float     X3_y   = 0F;
float     X5_x   = 0F;
float     X5_y   = 0F;
//--------------------------- right points ----------------------
float     X2_x   = 0F;
float     X2_y   = 0F;
float     X4_x   = 0F;
float     X4_y   = 0F;
float     X6_x   = 0F;
float     X6_y   = 0F;
//--------------------------- left arc points -----------------------
float     X_1_x  = 0F;
float     X_1_y  = 0F;
float     X_3_x  = 0F;
float     X_3_y  = 0F;
float     X_5_x  = 0F;
float     X_5_y  = 0F;
//--------------------------- right arc points ----------------------
float     X_2_x  = 0F;
float     X_2_y  = 0F;
float     X_4_x  = 0F;
float     X_4_y  = 0F;
float     X_6_x  = 0F;
float     X_6_y  = 0F;
//--------------------------- tangent points -----------------------
float     T1_x   = 0F;
float     T1_y   = 0F;
float     T3_x   = 0F;
float     T3_y   = 0F;
float     T5_x   = 0F;
float     T5_y   = 0F;
//--------------------------- tangent points ----------------------
float     T2_x   = 0F;
float     T2_y   = 0F;
float     T4_x   = 0F;
float     T4_y   = 0F;
float     T6_x   = 0F;
float     T6_y   = 0F;
//----------------------- left centers ---------------------------
float     C1_x   = 0F;
float     C1_y   = 0F;
float     C3_x   = 0F;
float     C3_y   = 0F;
float     C5_x   = 0F;
float     C5_y   = 0F;
//---------------------- right centers ----------------------------
float     C2_x   = 0F;
float     C2_y   = 0F;
float     C4_x   = 0F;
float     C4_y   = 0F;
float     C6_x   = 0F;
float     C6_y   = 0F;
//---------------------- right radius -----------------------------
float     R1     = 0F;
float     R3     = 0F;
float     R5     = 0F;
//---------------------- left radius ------------------------------
float     R2     = 0F;
float     R4     = 0F;
float     R6     = 0F;
//----------------------- left angle -------------------------------------
float     alpha1 = 0F;
float     alpha3 = 0F;
float     alpha5 = 0F;
//------------------------ rignt angle -------------------------------------
float     alpha2 = 0F;
float     alpha4 = 0F;
float     alpha6 = 0F;
//-------------------------- left magic points ----------------------------------
float     P1_x   = 0F;
float     P1_y   = 0F;
float     P3_x   = 0F;
float     P3_y   = 0F;
float     P5_x   = 0F;
float     P5_y   = 0F;
//--------------------------right magic points -----------------------------------
float     P2_x   = 0F;
float     P2_y   = 0F;
float     P4_x   = 0F;
float     P4_y   = 0F;
float     P6_x   = 0F;
float     P6_y   = 0F;
//---------------------------- left meddle magic points --------------------------
float     P1g_x  = 0F;
float     P1g_y  = 0F;
float     P3g_x  = 0F;
float     P3g_y  = 0F;
float     P5g_x  = 0F;
float     P5g_y  = 0F;
//---------------------------- right meddle magic points ----------------------------
float     P2d_x  = 0F;
float     P2d_y  = 0F;
float     P4d_x  = 0F;
float     P4d_y  = 0F;
float     P6d_x  = 0F;
float     P6d_y  = 0F;
//---------------------------- magic point -------------------------------------
float     k      = 0F;
float     Q1_x   = 0F;
float     Q1_y   = 0F;
float     Q2_x   = 0F;
float     Q2_y   = 0F;
