//************************************ class Itineraire *************************************************
class Itineraire {
    int                lames[]          = new int[INDEX_MAX];                                                                                      //  position des lames
    int                entree_pave[]    = new int[INDEX_MAX];                                                                                      //  cote par lequel on entre dans le pave
    int                numero_train     = -1000;                                                                                                   //  numero du train affecte à cet itinéraire
    boolean            iti_affiche      = false;
    boolean            iti_change       = false;
    boolean            calcule_points   = true;
    boolean            cycle            = false;
    boolean            iti_en_attente   = false;
    boolean            iti_sur_place    = false; 
    int                duree_arret      = 0;
    int                cote_rouge_cli   = 0;
    
    Pave               pave_debut;                                                                                                                 //  pavé du debut de l'itinéraire (c'est un pavé non appareil de voie)
    Pave               pave_fin;
    Pave               pave_premier;
    Pave               pave_rouge_cli;
    Zone               zone_debut;
    Zone               zone_fin;
    Itineraire         iti_suivant;

    ArrayList<Zone>    zones_composant_iti  = new ArrayList<Zone>();                                                                               //  liste de toutes les zones d'un itinéraire donne
    ArrayList<Pave>    paves_composant_iti  = new ArrayList<Pave>();                                                                               //  liste de tous les paves d'un itinéraire donne
    ArrayList<Point>   points_composant_iti = new ArrayList<Point>();                                                                              //  liste de tous les points d'un itinéraire
    IntList            position_signaux_iti = new IntList();                                                                                       //  liste de tous les points d'un itinéraire qui ont un signal, dans le sens de l'itinéraire

    Itineraire() {
    }  //  constructeur
    
    //---------------------------------------------------- enregistrement() ----------------------------------------------------
    void enregistrement() {
        paves_composant_iti.clear();
        zones_composant_iti.clear();
        //----------------------- recup du trace "normal" ------------------------
        for (int i = 0; i < INDEX_MAX; i++) {
            pave = tco.paves[iti[i][0]][iti[i][1]];
            if (pave != null && !(iti[i][0] == 0 && iti[i][1] == 0)) {
                if (i == 0) {
                    pave_debut = pave;
                    for (Zone zone1 : toutes_zones) {
                        if (zone1.paves_composant_zone.contains(pave_debut)) {
                            zone_debut = zone1;                                                                                                    //  première zone
                            if (zone_debut.occupee) {
                                numero_train = pave_debut.numero_train1;
                            }
                        }
                    }
                }
                paves_composant_iti.add(pave);
                lames[i]         = iti[i][3];
                entree_pave[i]   = iti[i][5];
                courant          = i;
            }
        }
        pave_fin = tco.paves[iti[courant][0]][iti[courant][1]];
        for (Zone zone1 : toutes_zones) {
            if (zone1.paves_composant_zone.contains(pave_fin)) {
                zone_fin = zone1;                                                                                                                  //  derniere zone
                break;
            }
        }
    }
    //-------------------------------------------------- dessine_itineraire() ---------------------------------------------------
    void dessine_itineraire() {
        noStroke();
        int compteur_pave = -1;
        for (Pave pave0 : paves_composant_iti) {
            compteur_pave++;
            if (abs(pave0.numero_train1) == abs(numero_train)/* || abs(pave0.numero_train2) == abs(numero_train)*/) {
                pave0.lames             = lames[compteur_pave];
                pave0.entree_pave       = entree_pave[compteur_pave];
                affiche_itineraire(pave0);
            } else {
                break;
            }
        }
    }
    //-------------------------------------------------- efface_itineraire() ---------------------------------------------------
    void efface_itineraire() {
        int index = paves_composant_iti.size()-1;
        while (index > -1) {
            int numero_train_pave = paves_composant_iti.get(index).numero_train1;
            Pave pave0 = paves_composant_iti.get(index);
            pave0.feu_noir[0]       = false;
            pave0.feu_clignotant[0] = false;
            pave0.feu_noir[1]       = false;
            pave0.feu_clignotant[1] = false;
            pave0.affiche_iti_tempo = false;
            if (pave0.occupe) {
                if (numero_train_pave != numero_train) {
                    pave0.numero_train2 = 0;
                    paves_composant_iti.remove(index);
                }
            } else {
                pave0.numero_train1 = 0;
                paves_composant_iti.remove(index);
            }
            index--;
        }
        paves_composant_iti.trimToSize();
    }
    //---------------------------------------------------- calcule_points_iti() ----------------------------------------------------
    void calcule_points_iti() {
        int compteur_pave  = -1;
        int compteur_point = -1;
        iti_en_attente     = false;
        position_signaux_iti.clear();
        points_composant_iti.clear();
        for (Pave pave0 : paves_composant_iti) {
            compteur_pave++;
            int nb_points1 = 0;
            int nb_points2 = 0;
            int nb_points3 = 0;
            if (pave0.orientation  % 2 == 0) {
                nb_points1 = pave0.Formes45[lames[compteur_pave]].nb_points1;
                nb_points2 = pave0.Formes45[lames[compteur_pave]].nb_points2;
                nb_points3 = pave0.Formes45[lames[compteur_pave]].nb_points3;
            } else {
                nb_points1 = pave0.Formes[lames[compteur_pave]].nb_points1;
                nb_points2 = pave0.Formes[lames[compteur_pave]].nb_points2;
                nb_points3 = pave0.Formes[lames[compteur_pave]].nb_points3;
            }
            if (abs(pave0.numero_train1) == abs(numero_train) || abs(pave0.numero_train2) == abs(numero_train)) {                                  //  si le pavé courant a le même numéro de train que le numéro de train de l'itinéraire                                                                                                    //  si le pavé courant n'est pas encore réservé
                if (entree_pave[compteur_pave] == 0) {
                    for (int i = 0; i < nb_points1; i++) {
                        compteur_point++;
                        maj_point(pave0,  i, compteur_pave);
                    }
                    for (int i = nb_points1; i < nb_points1+nb_points2; i++) {
                        compteur_point++;
                        maj_point(pave0, i, compteur_pave);
                    }
                    for (int i = nb_points1+nb_points2; i < nb_points1+nb_points2+nb_points3; i++) {
                        compteur_point++;
                        maj_point(pave0, i, compteur_pave);
                    }
                    if (pave0.cible[1]) {
                        position_signaux_iti.append(compteur_point);                                                                               //  ajoute toutes les positions des signaux de l'itinéraire
                    }                    
                } else {
                    for (int i = 0; i < nb_points1; i++) {
                        compteur_point++;
                        maj_point(pave0, (nb_points1+nb_points2+nb_points3-i-1), compteur_pave);
                    }
                    for (int i = nb_points1; i < nb_points1+nb_points2; i++) {
                        compteur_point++;
                        maj_point(pave0, (nb_points1+nb_points2+nb_points3-i-1), compteur_pave);
                    }
                    for (int i = nb_points1+nb_points2; i < nb_points1+nb_points2+nb_points3; i++) {
                        compteur_point++;
                        maj_point(pave0, (nb_points1+nb_points2+nb_points3-i-1), compteur_pave);
                    }
                    if (pave0.cible[0]) {
                        position_signaux_iti.append(compteur_point);                                                                               //  ajoute toutes les positions des signaux de l'itinéraire
                    }
                }
            } else {                                                                                                                               //  on a atteint un pavé qui est déjà réservé par un autre train
                iti_en_attente = true;
                break;
            }
        }
        //------------------------------------ gestion du dernier pavé qui contient le CARRE par définition ---------------------------------------
                                                                                      println("-calcule points-calcul AVANT ------------- ");
                                                                                      for (Itineraire iti0 : tous_iti) {
                                                                                          print("numero_train = "+iti0.numero_train, iti0+" ");
                                                                                          int compt = -1;
                                                                                          for (Pave pave1 : iti0.paves_composant_iti) {
                                                                                              compt++;
                                                                                              print(pave1.numero_train1+" : "+pave1.numero_train2+" | "+pave1.c, pave1.l+" | "+pave1.lames+"["+iti0.lames[compt]+" | "
                                                                                              +pave1.entree_pave+"["+iti0.entree_pave[compt], pave1.occupe+" || ");
                                                                                          }
                                                                                          println(" iti_en_attente = "+iti0.iti_en_attente+" cycle = "+iti0.cycle+" iti_suivant = "+iti0.iti_suivant);
                                                                                          for (Zone zone1 : iti0.zones_composant_iti) {
                                                                                             print(zone1.ID_zone, " ");
                                                                                          }
                                                                                          print(" duree_arret =", iti0.duree_arret);
                                                                                          println();
                                                                                      }
                                                                                      println();
        Pave dernier_pave = paves_composant_iti.get(compteur_pave);                                                                                //  on simplifie l'écriture : c'est le dernier pavé accessible au train
        int cote_signal   = 1-entree_pave[compteur_pave];                                                                                          //  on simplifie l'écriture
        if (!iti_en_attente) {                                                                
            dernier_pave.pave_cible_zone[cote_signal] = dernier_pave;                                                                              //  le pavé_cible_zone[] est forcément le dernier pavé
            dernier_pave.cote_cible_zone[cote_signal] = cote_signal;                                                                               //  le cote_cible_zone[] est forcément 1-entree_pave[]
            if (dernier_pave.manoeuvre == 0) {
                dernier_pave.code_signal[cote_signal]      = CARRE;
                dernier_pave.couleur_feu[cote_signal]      = ROUGE;
                dernier_pave.pave_signal_suiv[cote_signal] = null;
                dernier_pave.cote_signal_suiv[cote_signal] = -1;
            } else {
                dernier_pave.code_signal[cote_signal]      = CARRE_VIOLET;
                dernier_pave.couleur_feu[cote_signal]      = VIOLET;
            }
        }
    }
    //--------------------------------------------- maj_point() ------------------------------------------------
    void maj_point(Pave _pave, int _position_dans_pave, int _compteur_pave) {                                                                
        Point point      = new Point();                                                                                                            //  on crée un nouveau point
        if (_pave.orientation  % 2 == 0) {                                                                                                         //  les coordonnées du point sont dans la forme. Elles dépendent donc de l'orientation de la forme
            point.coord = _pave.Formes45[lames[_compteur_pave]].points.get(_position_dans_pave);
        } else {
            point.coord = _pave.Formes[lames[_compteur_pave]].points.get(_position_dans_pave);
        }
        float X = bordure_x+(point.coord.x+(_pave.c+c_min+niveau/2F)*MAILLE)*zoom_x;                                                               //  on passe en coordonnées absolues
        float Y = bordure_y+(point.coord.y+(_pave.l+l_min+niveau/2F)*MAILLE)*zoom_y;
        point.coord = new PVector(X, Y, 0);                                                                                                        //  les coordonnées sont maintenant dans un PVector() 
        if (_pave.l > L_MAX) {                                                                                                                     //  décalage nécessaire si on est dans l'autre niveau
            point.coord = point.coord.add(-MAILLE*zoom_x/2F, -MAILLE*zoom_y*(L_MAX+0.5F), 0);
        }
        point.pave       = _pave;                                                                                                                  //  dans l'objet Point(), on sait sur quel pavé on est
        points_composant_iti.add(point);                                                                                                           //  on ajoute les points un par un dans points_composant_iti
        for (Zone zone1 : toutes_zones) {
            for (Pave pave0 : zone1.paves_composant_zone) {
                if (_pave == pave0) {
                    if (!zones_composant_iti.contains(zone1)) {
                        zones_composant_iti.add(zone1);                                                                                            //  on ajoute la zone dans zones_composant_iti
                    }
                }
            }
        }
    }
}
//------------------------------------------ dessine_tous_iti() --------------------------------------------------
void dessine_tous_iti() {
    for (Itineraire iti0 : tous_iti) {
        if (iti0.numero_train < 0) {
            if (iti0.iti_change) {
                if (iti0.iti_affiche) {
                    iti0.dessine_itineraire();                                                                                                     //  on dessine l'itinéraire, ce qui, entre autres, calcule tous les points dans chaque pave
                } else {
                    iti0.efface_itineraire(); 
                }
                iti0.iti_change = false;                                                                                                           //  la mise à jour des signaux n'est faite que quand un itinéraire a changé
            }
        }
    }
    for (Itineraire iti0 : tous_iti) {
        if (iti0.numero_train > 0) {
            if (iti0.iti_change) {
                if (iti0.iti_affiche) {
                    iti0.dessine_itineraire();                                                                                                     //  on dessine l'itinéraire, ce qui, entre autres, calcule tous les points dans chaque pave
                } else {
                    iti0.efface_itineraire();
                }
                iti0.iti_change = false;                                                                                                           //  la mise à jour des signaux n'est faite que quand un itinéraire a changé
            }
        }
    }
}
//-------------------------------------------------- dessine_itineraire_tempo() ---------------------------------------------------
void dessine_itineraire_tempo() {                                                                                                                  //  on dessine tous les itinéraires tempo
    if (itineraire != null) {
        noStroke();
        for (Itineraire iti0 : tous_iti_tempo) {
            int compteur_pave = -1;
            for (Pave pave0 : iti0.paves_composant_iti) {
                if (iti0.numero_train == -1000) {
                    compteur_pave++;
                    pave0.lames_tempo       = iti0.lames[compteur_pave];
                    pave0.entree_pave_tempo = iti0.entree_pave[compteur_pave];
                    affiche_itineraire(pave0);
                }
            }
        }
    }
}

//------------------------------------------ affiche_itineraire() --------------------------------------------------
void affiche_itineraire(Pave _pave) {                                                                                                              //  affiche l'itinéraire d'un seul pavé          
    if (_pave.l < L_MAX) {
        niveau = 0;
        bordure_x = int(BORDURE_X+MAILLE*zoom_x/2+.5);
        bordure_y = int(BORDURE_Y+MAILLE*zoom_y/2+.5);
        tco.dessine_pave_du_tco(_pave);
    } else {
        niveau = 1;
        bordure_x = BORDURE_X;
        bordure_y = BORDURE_Y;
        tco.dessine_pave_du_tco(_pave);
    }
}
//--------------------------------------- efface_iti_tempo() --------------------------------------------------------
void efface_iti_tempo(int _numero_train) {  
    int index = tous_iti_tempo.size()-1;
    if (_numero_train == 1000) {
        while (index > -1) {
            if (tous_iti_tempo.get(index).numero_train == 1000) {
                for (Pave pave0 : tous_iti_tempo.get(index).paves_composant_iti) {
                    pave0.affiche_iti_tempo = false;
                }
                tous_iti_tempo.remove(index);
            }
            index--;
        }
    } else {
        while (index > -1) {
            if (abs(tous_iti_tempo.get(index).numero_train) == abs(_numero_train)) {
                for (Pave pave0 : tous_iti_tempo.get(index).paves_composant_iti) {
                    pave0.affiche_iti_tempo = false;
                }
                tous_iti_tempo.remove(index);
            }
            index--;
        }
    }
    tous_iti_tempo.trimToSize();                                                                                                                   //  on n'a plus d'autre itinéraire affiche que celui qui contient le train
    for (Itineraire iti0 : tous_iti_tempo) {
        for (Pave pave0 : iti0.paves_composant_iti) {
            pave0.affiche_iti_tempo = true;
        }        
    }
}
//--------------------------------------- prolonge_numero_train() ----------------------------------------------------
void prolonge_numero_train(Itineraire _itineraire) {
    if (_itineraire.numero_train > 0) {
        int compteur_paves             = -1;
        int compteur_appareils_de_voie = 0;
        for (Pave pave0 : _itineraire.paves_composant_iti) {
              compteur_paves++;
              if (abs(pave0.numero_train1) == _itineraire.numero_train || pave0.numero_train1 == 0 || pave0.numero_train1 == -1000) {
                  pave0.carre_manuel = false;                                                                                                      //  on ne peut pas avoir de carré manuel en plein milieu de l'itinétraire
                  if (!pave0.appareil_de_voie) {
                      for (int i = compteur_paves; i > compteur_paves-compteur_appareils_de_voie-1; i--) {
                          _itineraire.paves_composant_iti.get(i).numero_train1 = _itineraire.numero_train;                                         //  on donne au pavé le même numero_train que celui de l'itinéraire
                      }
                      compteur_appareils_de_voie = 0;
                  } else {
                      compteur_appareils_de_voie++;
                  }
              } else {
                  break;
              }
        }
    }
    _itineraire.dessine_itineraire();
    _itineraire.calcule_points_iti();
    if (_itineraire.numero_train > 0) {
        pupitre.trouve_train(_itineraire.numero_train);
        if (train_trouve.debut_train >= 0) {
            for (int pos = 0; pos < _itineraire.points_composant_iti.size(); pos++) {
                if (PVector.dist(_itineraire.points_composant_iti.get(pos).coord,                                                                  //  on recherche la position future du train sur le nouvel itinéraire
                    train_trouve.coord_debut_train) < 0.1) {                                                                                       //  elle correspond à debut_train
                    train_trouve.debut_train = pos;
                    break;
                }
            }
        }
    }
    pupitre.trains[abs(_itineraire.numero_train)].efface_iti_tempo = false;                                                                         //  on réinitialise le système qui permet deffacer les feux noirs quand le train avance
}
