//******************************************************************* Menu **********************************************************************************
void menu() {
    if ((mouseX < width-CURSEUR-2 && mouseY >= 0.80F*height && mouseY < height-50) || aide) {
        stroke(NOIR);
        strokeWeight(1);
        fill(FOND);
        quad(80F, height-60F-CURSEUR, width-80F, height-60F-CURSEUR, width-50F, height-40F-CURSEUR, 50F, height-40F-CURSEUR);       
        fill(BLANC);
        rect(50F, height-40F-CURSEUR, width-100F, 35F);
        //texte_affiche    = ".";
        //couleur_affichee = BLANC;
        
        int     nombre_boutons = 6;
        float   premiere_icone = width/4F;
        float[] loupe          = new float[50];                                                                                                      //  loupe[], c'est le coefficient de grossissement de chaque bouton
        float[] emplacement    = new float[50];
        float   somme_nombres  = 0F;                                                                                                                 //  largeur totale, c'est la somme des largeurs de tous les boutons
        float   curseur_loupe  = (mouseX-premiere_icone)/(width-2F*premiere_icone);                                                                  //  curseur_loupe, c'est un nombre ramene à l'intervalle [0-1] en partant de [50, Width-50]
        int     nombre_petits  = 0;                                                                                                                  //  nombre_petits, c'est le nombre de boutons de largeur_un
        if (curseur_loupe < 0) { curseur_loupe = 0; }
        if (curseur_loupe > 1) { curseur_loupe = 1; }
        curseur_loupe = curseur_loupe*(nombre_boutons);
        //--------------------------------------------------- calcul courbe de Gauss ----------------------------------------------------
        float sigma = 2F;
        for (int numero_bouton = 0; numero_bouton < nombre_boutons; numero_bouton++) {
            loupe[numero_bouton] = (2F/sigma)*exp(-(numero_bouton+1-curseur_loupe)*(numero_bouton+1-curseur_loupe)/4F/sigma/sigma)+1F;
            somme_nombres = somme_nombres+loupe[numero_bouton];
            if (loupe[numero_bouton] < 1.01F) { nombre_petits = nombre_petits+1; }
        }
        //------------------------------------------------ petits et gros boutons -------------------------------------------------------
        int     debut_gros = 0;
        int     fin_gros   = 0;
        boolean debut      = false;        
        fill(NOIR);
        for (int numero_bouton = 0; numero_bouton < nombre_boutons; numero_bouton++) {
            if (loupe[numero_bouton] < 1.01F) {
                if (debut) {
                    fin_gros = numero_bouton;
                    break;
                } else {
                    debut_gros = numero_bouton;
                }
            } else {
                debut = true;
            }
        }
        if (fin_gros == 0) { fin_gros = nombre_boutons-1; }
        nombre_petits = nombre_boutons-(fin_gros-debut_gros+1);
        //------------------------------------ dessin des boutons ---------------------------------------------------------------------------
        float coeff_intervalle   = 1.1F;                                                                                                             //  l'intervalle correspond à 10 pour cent de la largeur d'un bouton
        float largeur_petit      = 0.3F*(width-2F*premiere_icone)/nombre_boutons;                                                                    //  largeur_bouton, c'est la largeur d'un bouton de largeur_des_petits
        float largeur_des_petits = largeur_petit*nombre_petits*coeff_intervalle;                                                                     //  largeur_des_petits, c'est la largeur du plus petit bouton * son coeff_intervalle
        float largeur_des_gros   = (width-2F*premiere_icone)-largeur_des_petits;                                                                     //  largeur_gros, c'est la largeur totale de l'emplacement des gros bouton
        float largeur_gros       = largeur_des_gros/(somme_nombres-nombre_petits)/coeff_intervalle;                                                  //  intervalle, c'est la largeur (variable) entre les gros boutons
        float emplacement_bouton = premiere_icone;
        for (int numero_bouton = 0; numero_bouton < nombre_boutons; numero_bouton++) {
            emplacement[numero_bouton] = emplacement_bouton;
            if (numero_bouton < debut_gros || numero_bouton > fin_gros) {                                                                            //  petits boutons
                emplacement_bouton = emplacement_bouton+largeur_petit*coeff_intervalle;
            } else {                                                                                                                                 //  gros boutons
                emplacement_bouton = emplacement_bouton+loupe[numero_bouton]*largeur_gros*coeff_intervalle;
            }
        }
        emplacement[nombre_boutons] = emplacement_bouton;
        for (int numero_bouton = 0; numero_bouton < nombre_boutons; numero_bouton++) {
            if (numero_bouton < debut_gros || numero_bouton > fin_gros) {                                                                            //  petits boutons
                image(fond_bouton[numero_bouton],  emplacement[numero_bouton],   height-56F-CURSEUR-largeur_petit,                      largeur_petit,                       largeur_petit);
                image(ombre_bouton[numero_bouton], emplacement[numero_bouton],   height-52F-CURSEUR,                                    largeur_petit,                       10F);
            } else {                                                                                                                                 //  gros boutons
                image(fond_bouton[numero_bouton],  emplacement[numero_bouton],   height-56F-CURSEUR-largeur_gros*loupe[numero_bouton],  largeur_gros*loupe[numero_bouton],   largeur_gros*loupe[numero_bouton]);
                image(ombre_bouton[numero_bouton], emplacement[numero_bouton],   height-52F-CURSEUR,                                    largeur_gros*loupe[numero_bouton],   10F);
            }
            if ((mouseX > emplacement[numero_bouton] && mouseX < emplacement[numero_bouton+1]) && (mouseY >= 0.80F*height && mouseY < height-50)){
                position_bouton = numero_bouton;                                                                                                     //  la position bouton est l'ordre du bouton pour les clics
            }
        }
        noStroke();
    }
}
//------------------------------------------ affiche_texte() -----------------------------------------------------
void affiche_texte(String _texte, int _couleur) {
    textFont(fontMessage);
    textAlign(CENTER, CENTER);
    stroke(NOIR);
    strokeWeight(2);
    fill(_couleur);
    rect(50F, height-40F-CURSEUR, width-100F, 35F);
    fill(NOIR);
    textSize(8);
    text(_texte, 50F, height-40F-CURSEUR, width-100F, 35F);
}
//------------------ key_zoom() --------------------
void key_zoom_pupitre() {                                                                                                                            //  le pupitre est affiche : le zoom s'applique à lui
    pupitre.zoom_p = max(1, int(pupitre.zoom_p+zoom_change));
    zoom_change      = 0;
    one_shot         = true;
}
//------------------ key_zoom2() --------------------
void key_zoom_tco() {                                                                                                                                //  le pupitre est affiche : le zoom s'applique à lui
    zoom_x = max(1, int(zoom_x+zoom_change));
    zoom_y = zoom_x;
    zoom_change      = 0;
    one_shot         = true;
}
//-------------------------------------------------------------------------- Key() -------------------------------------------------------
void keyPressed() {
    if (key != CODED) {
        switch (key) {
            //------------------ recherche du signal suivant et précèdent --------------
            case 'D':
                etiquettes_pont = !etiquettes_pont;
                break;
            case 'G':  //------------------ grille --------------
                affiche_coordonnees = !affiche_coordonnees;
                break;
        }
    }
}
//*************************************************************************************************************************************************************
//*************************************************************************************************************************************************************
//************************************ class Zone *************************************************
class Zone {
    String    ID_zone;
    float     longueur_zone  = 0F;
    boolean   occupee        = false;
    boolean   effacable      = false;
    
    ArrayList<Pave>    paves_composant_zone  = new ArrayList<Pave>();                                                                                //  liste de tous les paves composant la zone 
    
    Zone() { }  //constructeur
}
//*************************************************************************************************************************************************************
//*************************************************************************************************************************************************************
//***************************************************** class Point *******************************************************************************************
class Point {
    PVector    coord;                                                                                                                                //  on recupere les coordonnées de la forme (x, y, alpha)
    
    Pave       pave;                                                                                                                                 //  le pavé dans lequel est le point

    Point() { }  //constructeur
}
//*************************************************************************************************************************************************************
//*************************************************************************************************************************************************************
//************************************ class Vehicule *********************************************************************************************************
class Vehicule {
    int         position       = 0;                                                                                                                  //  position du véhicule
    int         numero_train   = -1000;
    int         nb_points_veh  = 0;
    float       angle          = 0F;
    float       longueur       = 0;
    float       largeur        = 0;
    PVector     pointAV;
    PVector     pointAR;
    boolean     attele_fin     = true;
    boolean     image_inverse  = false;
    //------------------------------------- description -----------------
    int         ident          = -1;
    boolean     moteur         = false;
    color       couleur        = 0;                                                                                                                  //  couleur du véhicule
    int         htamp          = 0;
    String      nom;
    PImage      image_dessus;
    PImage      image_cote;
    String      marque;
    String      ref;
    String      dcc;
    
    Itineraire  iti_train;

    Vehicule() { }  //  constructeur
    Vehicule copy() { return null; }
    //----------------------------------------------------------------------------- dessine_vehicule() -----------------------------------------------------------
    void dessine_vehicule(){
        if (moteur) {                                                                                                                                //--- matériel moteur
            train_pupitre(iti_train.numero_train);
            PVector v_loco;
            largeur  = 2F*RAIL*zoom_x;
            longueur = largeur*image_dessus.width/image_dessus.height;
            pointAV  = iti_train.points_composant_iti.get(position).coord;
            pointAR  = iti_train.points_composant_iti.get(max(0, int(position-longueur/PAS/zoom_x))).coord;
            v_loco   = new PVector(pointAV.x-pointAR.x, pointAV.y-pointAR.y);
            angle    = v_loco.heading();                                                                                                             //  donne l'angle par rapport à l'horizontale
            if (image_inverse) {
                angle = angle+PI;
            }
            //---------------------- dessine loco ---------------------
            pushMatrix();                                                                                                                            // sauvegarde des transformations
                translate((pointAV.x+pointAR.x)/2F, (pointAV.y+pointAR.y)/2F);
                rotate(angle);
                if (pupitre.presse[num_train_pupitre][0]) {
                    fill(BLANC);
                    quad(0, -largeur/4F, 12F*zoom_x, -largeur/3F, 12F*zoom_x, largeur/3F, 0, largeur/4F);
                    noFill();
                }
                imageMode(CENTER);
                image(image_dessus, 0, 0, longueur, largeur);
                imageMode(CORNER);
            popMatrix();                                                                                                                             // restauration des transformations
        } else {                                                                                                                                     //--- matériel remorqué
            if (image_cote != null) {            
                largeur  = 2F*RAIL*zoom_x;
                longueur = largeur*image_cote.width/image_cote.height;
            }
            pointAV = iti_train.points_composant_iti.get(position).coord;
            pointAR = iti_train.points_composant_iti.get(max(0, int(position-longueur/PAS/zoom_x))).coord;
            stroke(couleur);
            strokeWeight(largeur);
            strokeCap(ROUND);
            line(pointAV.x, pointAV.y, pointAR.x, pointAR.y);                                                                                        // dessiner le véhicule
            strokeWeight(1);
        }
        nb_points_veh = int((PVector.dist(pointAV, pointAR)+0.5)/PAS/zoom_x);            
    }
    //-------------------------------------------- dessine aiguille -------------------------------------------
    void dessine_aiguille() {
        //---------------------- dessine aiguille pupitre ------------------
        if (moteur) {
            train_pupitre(iti_train.numero_train);
            pushMatrix();                                                                                                                            // sauvegarde des transformations
                if (position > 1) {
                    fill(couleur);
                    noStroke();
                    float x_centre_aiguille = x_pupitre+((num_train_pupitre-1)*2F*largeur_tuile+24F*largeur_pixel)*pupitre.zoom_p;                   //  numero_pupitre-1 pour le dessin
                    float y_centre_aiguille = y_pupitre+4.6F*hauteur_tuile*pupitre.zoom_p;
                    translate(x_centre_aiguille, y_centre_aiguille);
                    if (image_inverse) {
                        rotate(angle+PI);
                    } else {
                        rotate(angle);
                    }
                    triangle(-2F*pupitre.zoom_p/12F, -2F*pupitre.zoom_p/12F, 4F*pupitre.zoom_p/12F, 0F, -2F*pupitre.zoom_p/12F, 2F*pupitre.zoom_p/12F);
                }
                noFill();
            popMatrix();                                                                                                                             // restauration des transformations
        }
    }
}
//***************************************************************************************************************************************************************************
class VehiculeCopy extends Vehicule {
    VehiculeCopy(int _ordre) {
        ordre          = _ordre;
        if (ordre != -1) {
            ident          = tous_vehicules.get(ordre).ident;
            moteur         = tous_vehicules.get(ordre).moteur;
            couleur        = tous_vehicules.get(ordre).couleur;                                                                                      //  couleur du véhicule
            nom            = tous_vehicules.get(ordre).nom;
            htamp          = tous_vehicules.get(ordre).htamp;
            image_dessus   = tous_vehicules.get(ordre).image_dessus;
            image_cote     = tous_vehicules.get(ordre).image_cote;
        } else {
            ident          = -1;
            moteur         = false;
            couleur        = ROUGE;                                                                                                                  //  couleur du véhicule
            htamp          = 0;
            nom            = "vide";
            image_dessus   = null;
            image_cote     = null;
        }
    }
    Vehicule copy() { return new VehiculeCopy(ordre); }
}
