//************************************************** class Pupitre() *********************************************
class Pupitre {

    int     l_max_p           = 3;                                                                                                                  // nombre de lignes du pupitre
    int     zoom_p            = 3;                                                                                                                  //  zoom pupitre
    boolean selectionne       = false;
    boolean dans_les_pupitres = false;
    PShape  aig;
    
    int   previous_c_p          = 0;
    int   previous_l_p          = 0;
    int   couleur_pave          = BLANC;
    boolean  bloque[]           = new boolean[C_MAX_P];
    boolean  moteur[]           = new boolean[C_MAX_P];
    boolean  presse[][]         = new boolean[C_MAX_P][29];                                                                                         //  29 fonctions DCC
    boolean  horloge[]          = new boolean[C_MAX_P];
    int      box_p[]            = new int[C_MAX_P];
    
    Pupitre() {
        aig = createShape();
    }            //  constructeur
    Bouton bouton;
    CabSignal cabs[]            = new CabSignal[C_MAX_P];
    Train trains[]              = new Train[C_MAX_T];
    //----------------------------------------------------- gere_trains() ---------------------------------------------------------
    void gere_trains() {
        int memo_rang = 0;
        for (int numero_train = 1; numero_train < liste_trains.size()+1; numero_train++) {
            train = trains[numero_train];
            if (train != null) {
                for (Itineraire iti0 : tous_iti) {
                    if (iti0.numero_train == numero_train) {
                        train.numero_train   = iti0.numero_train;                                                                                   //  affectation d'un numero de train au train (> 0)
                        train.iti_train      = iti0;                                                                                                //  affectation d'un itinéraire à un train
                    }
                }                
                train.gere_train();                                                                                                                 //  on gère ce train
                int compteur_iti = -1;
                //------------------------- transfert du train de l'itinéraire iti_train vers iti0 --------------
                if (train.transfert) {
                    for (Itineraire iti0 : tous_iti) {
                        compteur_iti++;
                        if (iti0 == train.iti_train) {
                            memo_rang = compteur_iti;                                                                                               //  on mémorise le rang à supprimer
                        }
                        if (iti0 == train.iti_double) {
                            train.iti_train                = train.iti_double;                                                                      //  on transfère le nouvel iti
                            train.iti_train.numero_train   = numero_train;                                                                          //  on transfère le numero de train (> 0)
                        }
                    }
                    tous_iti.remove(memo_rang);                                                                                                     //  on efface l'itinéraire marqué
                    tous_iti.trimToSize();
                    train.iti_train.zones_composant_iti.clear();
                    prolonge_numero_train(train.iti_train);                                                                                         //  on essaie de prolonger le numero_train aussi loin que possible
                    train.debut_train           = train.position_double;                                                                            //  on remet le train à la nouvelle bonne position
                    train.position_double       = 0;                                                                                                //  on remet à zéro la position_double
                    train.transfert             = false;                                                                                            //  le transfert est fait
                    train.iti_train.iti_change  = true;                                                                                             //  l'itinéraire va changer
                    train.iti_train.iti_affiche = true;                                                                                             //  l'itinéraire sera affiché
                    train.nouvelle_position     = train.debut_train;                                                                                //  la "nouvelle position" est le nouveau debut_train
                    train.arret_en_gare         = false;                                                                                            //  réinitialisation du redémarrage direct
                }
            }
        }
    }
    //-------------------------------------------- position_train() -------------------------------------------------------
    void trouve_train(int _numero_train) {
        train_trouve = trains[_numero_train];
    }
    //----------------------------------------------------- dessine_trains() ---------------------------------------------------------
    void dessine_trains() {
        for (int numero_train = 1; numero_train < liste_trains.size()+1; numero_train++) {                                                          //  le numero de train, c'est le rang de la liste des trains
            train = trains[numero_train];                                                                                                           //  on définit le train //<>//
            if (train != null && train.iti_train != null) {
                train.debut_train                  = min(int(train.debut_train+train.vitesse), train.iti_train.points_composant_iti.size()-1);      //  le train ne peut pas depasser la fin de l'itinéraire
                train.positions_vehicules();
                train.dessine_train(numero_train);
                train_pupitre(numero_train);
                if (num_train_pupitre > 0) {
                    if (!horloge[num_train_pupitre]) {                                                                                              //  si on n'a pas l'horloge, on affiche la consigne
                        consigne_train[num_train_pupitre] = int(0.5+(hauteur_curseur[num_train_pupitre]*hauteur_curseur[num_train_pupitre]/127));   //  croissance en x²
                        train.consigne                      = consigne_train[num_train_pupitre];
                    }
                    vitesse[num_train_pupitre]            = int(0.5+(train.vitesse*train.vitesse/127));
                }
                if (train.pave_feu != null) {
                    if (!horloge[num_train_pupitre] && num_train_pupitre > 0) {                                                                     //  le numero de pupitre démarre à 0, le numero de train à 1
                        dessine_cabs_pupitre(num_train_pupitre-1, train.pave_feu.code_signal[1-train.pave_feu.entree_pave]);                        //  dessine le cab signal dans le pupitre
                    }
                }                
            }
        }
    }
    //--------------------------------------------------------------------- affiche_train() -----------------------------------------------
    void affiche_train() {
        //---------------------------- dessine le point noir du pupitre -------------------------------
        if (choix_train != -1) {
            train_pupitre(choix_train);
            noStroke();
            fill(NOIR);
            ellipse(x_pupitre+(2F*(num_train_pupitre-1)+0.50F*largeur_tuile)*pupitre.zoom_p, 
                    y_pupitre+4.6F*hauteur_tuile*pupitre.zoom_p, 10, 10);
        }
        //------------------------ sauve la composition du train au départ -------------------------
        if (!affiche_train_sauve_initial && choix_train != -1) {
            affiche_train_sauve_initial = true;
            trains[choix_train].compo_train_ter.clear();
            int taille = trains[choix_train].compo_train.size();
            for (int i = 0; i < taille; i++) {
                trains[choix_train].compo_train_ter.add(trains[choix_train].compo_train.get(i));
            }
        }
        noStroke();
        image(fond_affiche_trains, int((width-1366)/2+.5), (height-200));
        //--------------------- donne le nom du gros bouton en bas à droite ------------
        textFont(fontMessage);
        textAlign(CENTER, CENTER);
        noStroke();
        fill(NOIR);
        strokeWeight(2);
        textSize(6);
        if (affiche_exit) {
            text("EXIT", (width-1366)/2+1280, (height-200)+145, 70, 35);
        } else {
            text("VALIDE", (width-1366)/2+1280, (height-200)+145, 70, 35);
        }
        int memo_d = -1;
        int memo_u = -1;
        for (int d = 0; d < 2; d++) {
            for (int u = 0; u < 10; u++) {
                if (choix_train == -1) {                                                                                                            //--- si on n'a pas sélectionné de train : FOND_TRAIN
                    fill(FOND_TRAIN);
                    rect(int((width-1366)/2+.5)+17+u*135, (height-200)+17+d*65, 96, 46);
                } else {                                                                                                                            //--- si on a sélectionné un train
                    if (10*d+u >= trains[choix_train].compo_train.size()) {                                                                         //----- si on a dépassé le nombre de véhicules : FOND_TRAIN
                        fill(FOND_TRAIN);
                        rect(int((width-1366)/2+.5)+17+u*135, (height-200)+17+d*65, 96, 46);
                    } else {                                                                                                                        //----- si on est dans un véhicule, on peut l'afficher
                        Vehicule veh1 = trains[choix_train].compo_train.get(10*d+u);                                                                //  simplification d'écriture pour le choix du véhicule //<>//
                        if (veh1.ident == -1) {                                                                                                     //------- si on est arrivé à un véhicule null : ROUGE
                            fill(ROUGE);
                            rect(int((width-1366)/2+.5)+17+u*135, (height-200)+17+d*65, 96, 46);
                        } else {                                                                                                                    //------- si on est dans un véhicule normal, on l'affiche
                            imageMode(CENTER);
                            fill(veh1.couleur);
                            if (veh1.image_inverse) {
                                pushMatrix();
                                    translate((u+1)*96+u*(135+39)+2*int((width-1366)/2+.5), 0);
                                    scale(-1, 1);
                                    rect(int((width-1366)/2+.5)-17+u*135, (height-200)+17+d*65, 96, 46);
                                    image(veh1.image_cote, int((width-1366)/2+.5)-17+u*135+48, (height-200)+17+d*65+23, min(96, veh1.image_cote.width/10), veh1.image_cote.height*min(96, veh1.image_cote.width/10)/veh1.image_cote.width);
                                popMatrix();
                            } else {
                                rect(int((width-1366)/2+.5)+17+u*135, (height-200)+17+d*65, 96, 46);
                                image(veh1.image_cote, int((width-1366)/2+.5)+17+u*135+48, (height-200)+17+d*65+23, min(96, veh1.image_cote.width/10), veh1.image_cote.height*min(96, veh1.image_cote.width/10)/veh1.image_cote.width);
                            }
                            imageMode(CORNER);
                            //---------------------- affiche nom du véhicule ------
                            textFont(fontMessage);
                            textAlign(CENTER, CENTER);
                            noStroke();
                            fill(AQUA);
                            strokeWeight(2);
                            textSize(6);
                            text(veh1.nom, int((width-1366)/2+.5)+(u-1+(max(-1, -int((width-1366)+.5))+1))*135, (height-200)+64+d*65, int((width-1366)/2+.5)+120, 14F);     // [max(-1, -X)+1] vaut 1 si X = 0 et vaut 0 pour tout autre nombre > 0
                            //--------------------- affiche l'attelage -------------
                            if (numero_attelage == -1000) {
                                fill(AQUA);
                                rect(int((width-1366)/2+.5)+0*135, (height-200)+35+0*65, 17, 10);
                            }
                            if (10*d+u < trains[choix_train].compo_train.size()-1 || abs(numero_attelage) == trains[choix_train].compo_train.size()) {
                                if (trains[choix_train].compo_train.get(10*d+u).attele_fin) {
                                    fill(AQUA);
                                } else {
                                    noFill();
                                }
                                rect(int((width-1366)/2+.5)+115+u*135, (height-200)+35+d*65, 34, 10);
                            }
                            if (mouseX > (width-1366)/2+17+30+u*135 && mouseX < (width-1366)/2+113-30+u*135                                                                        //  bouton du haut : véhicule 10*d+u
                             && mouseY > (height-200)+17+10+d*65    && mouseY < (height-200)+63-10+d*65) {
                                 memo_d = d;
                                 memo_u = u;
                            }
                        }
                    }
                }
            }
        }
        if (choix_train != -1 && memo_u > -1 && !mousePressed) {
            Vehicule veh1 = trains[choix_train].compo_train.get(10*memo_d+memo_u);                                                                                           //  simplification d'écriture pour le choix du véhicule
            fill(veh1.couleur);
            imageMode(CENTER);
            rect(min((width-288), max(0, int((width-1366)/2+.5)+17+memo_u*135-96)), (height-200)+17+memo_d*65-46, 288, 138);
            if (veh1.image_inverse) {
                pushMatrix();
                    translate(130+2*135*memo_u+(max(-1, -memo_u)+1)*((144+15*(max(-1, -int((width-1366)+.5))+1))-int((width-1366)/4+.5))+2*int((width-1366)/2+.5), 0);           // [max(-1, -X)+1] vaut 1 si X = 0 et vaut 0 pour tout autre nombre > 0
                    scale(-1, 1);
                    image(veh1.image_cote, min((width-144), max(144, int((width-1366)/2+.5)+17+memo_u*135+48))+(max(-1, -(9-memo_u))+1)*(max(-1, -(int((width-1366)+.5)))+1)*(144-2*16),
                                          (height-200)+17+memo_d*65+23, 
                                           min(288, veh1.image_cote.width), veh1.image_cote.height*min(288,
                                           veh1.image_cote.width)/veh1.image_cote.width);
                popMatrix();
            } else {
                image(veh1.image_cote, min((width-144), max(144, int((width-1366)/2+.5)+17+memo_u*135+48)),
                                      (height-200)+17+memo_d*65+23, 
                                       min(288, veh1.image_cote.width),
                                       veh1.image_cote.height*min(288, veh1.image_cote.width)/veh1.image_cote.width);
            }
            imageMode(CORNER);
        }
        //--------------------------- affiche un petit rectangle à gauche ou à droite --------------
        if (choix_train != -1) {
            int taille     = train.compo_train.size();
            int taille_bis = train.compo_train_bis.size();
            if (taille_bis > 0 && taille != taille_bis) {
                for (int d = 0; d < 2; d++) {
                    for (int u = 0; u < 10; u++) {
                        if (taille < taille_bis) {
                            //--------------------------------- insertion d'un véhicule -----------------------
                            if (10*d+u < taille_bis && 10*d+u >= memo_case) {
                                fill(train.compo_train_bis.get(10*d+u).couleur);
                                triangle(int((width-1366)/2+.5)+82+u*135, (height-200)+17+d*65, int((width-1366)/2+.5)+82+u*135, (height-200)+17+46+d*65, int((width-1366)/2+.5)+82+30+u*135, (height-200)+17+23+d*65);
                            }
                            texte_affiche_train   = "Validez pour insérer un véhicule à partir de la position indiquée en rouge. Pour ne pas insérer, appuyer sur le bouton 'annule'";
                            couleur_affiche_train = SABLE;
                        } else {
                            //-------------------------------- suppression d'un véhicule -----------------------
                            if (10*d+u < taille_bis && 10*d+u == memo_case) {
                                fill(train.compo_train_bis.get(10*d+u).couleur);
                                triangle(int((width-1366)/2+.5)+17+u*135, (height-200)+17+23+d*65, int((width-1366)/2+.5)+17+30+u*135, (height-200)+17+d*65, int((width-1366)/2+.5)+17+30+u*135, (height-200)+17+46+d*65);
                            }
                            texte_affiche_train   = "Validez pour supprimer le véhicule indiqué. Pour ne pas le supprimer, appuyer sur le bouton 'annule'";
                            couleur_affiche_train = SABLE;
                        }
                    }
                }
            }
        }
        //-------------------------- affiche texte dans affiche_train --------------------------
        if (!texte_affiche_train.equals(".")) {                                                                                                     //  affiche le texte des messages
            textFont(fontMessage);
            textAlign(CENTER, CENTER);
            strokeWeight(2);
            fill(couleur_affiche_train);
            rect(int((width-1366)/2+.5)+18, (height-200)+148, int((width-1366)/2+.5)+1196, 32);
            fill(NOIR);
            textSize(8);
            text(texte_affiche_train, int((width-1366)/2+.5)+18, (height-200)+148, int((width-1366)/2+.5)+1214, 32);
        }
    }
    //***********************************************************************************************************************************
    //-------------------------------- dessine_pupitres() ----------------------------------------
    void dessine_pupitres() {
        int numero_pupitre = 0;
        for (int numero_pupitre0 : liste_trains) {                                                                                                  //  numero_pupitre0 démarre à 1 : on retire 1 pour dessiner
            if (numero_pupitre0 != 0) {
                pupitre.dessine_pupitre(x_pupitre, y_pupitre, numero_pupitre);                                                                      //  dessine le pupitre 
                pupitre.dessine_curseur_pupitre(numero_pupitre);                                                                                    //  dessine le curseur en fonction de sa derniere position de la souris
                pupitre.dessine_bargraph_pupitre(numero_pupitre);                                                                                   //  dessine les bargraphs en fonction des vitesses des trains
                pupitre.dessine_texte_pupitre(numero_pupitre0);                                                                                     //  dessine le texte des boutons DCC
                pupitre.test_bouton();                                                                                                              //  teste les 29 boutons DCC
                if (pupitre.horloge[numero_pupitre0]) {
                    pupitre.dessine_digits_horloge(numero_pupitre);                                                                                 //  on ne retire pas 1 car ce n'est pas un dessin
                } else {
                    pupitre.dessine_digits_consigne(numero_pupitre);                                                                                //  dessine les digits en fonction de la position des curseurs
                    pupitre.dessine_digits_vitesse(numero_pupitre);                                                                                 //  dessine les digits en fonction de la vitesse des trains
                }
                numero_pupitre++;
            }
        }
    }
    //------------------------------- dessine_pupitre() ------------------------------------------
    void dessine_pupitre(int _x_pupitre, int _y_pupitre, int _numero_pupitre) {                                                                     //  c'est un dessin : le numero de pupitte démarre à 0
        x_mouse_p = bordure_x+_x_pupitre;
        y_mouse_p = bordure_y+_y_pupitre;
        if (fond_pupitre.width == 0) {
            largeur_tuile = 0;
        } else {
            largeur_tuile = float(fond_pupitre.width/largeur_fond_pupitre/2);
        }    
        if (fond_pupitre.height == 0) {
            hauteur_tuile = 0;
        } else {
            hauteur_tuile = float(fond_pupitre.height/hauteur_fond_pupitre/5);
        }
        if (horloge[_numero_pupitre+1]) {                                                                                                           //  on ajoute 1 car ce n'est pas un dessin                                                                                                                         
            image(fond_pupitre_horloge,
                  _x_pupitre+2*_numero_pupitre*largeur_tuile*zoom_p,
                  _y_pupitre+l_max_p/5*hauteur_tuile*zoom_p,
                  2*largeur_tuile*zoom_p,
                  5*hauteur_tuile*zoom_p);
        } else {
                image(fond_pupitre,
                      _x_pupitre+2*_numero_pupitre*largeur_tuile*zoom_p,
                      _y_pupitre+l_max_p/5*hauteur_tuile*zoom_p,
                      2*largeur_tuile*zoom_p,
                      5*hauteur_tuile*zoom_p);
        }
        if (numero_point_train != -1) {
            noStroke();
            fill(NOIR);
            ellipse(_x_pupitre+(2F*numero_point_train+0.50F*largeur_tuile)*zoom_p, _y_pupitre+4.6F*hauteur_tuile*zoom_p, 10, 10);
        }
    }
    //---------------------------------- dessine_curseur_pupitre() ---------------------------------------------------------
    void dessine_curseur_pupitre(int _numero_pupitre) {                                                                                             //  c'est un dessin : le numero de pupitte démarre à 0
        float course_curseur = (curseur_down-curseur_up)/20F;
        image(image_curseur[_numero_pupitre+1],
              x_pupitre+(2F*_numero_pupitre+largeur_tuile/5F+.01F)*zoom_p,
              y_pupitre+(curseur_down+(curseur_up-curseur_down)*hauteur_curseur[_numero_pupitre+1]/127F-course_curseur)*zoom_p,                      
              zoom_p*(largeur_tuile/5F),
              1.5F*zoom_p*(largeur_tuile/5F));                                                                                                      //  l'image du curseur suit exactement la position de la souris
    }
    //---------------------------------- dessine_bargraph_pupitre() ---------------------------------------------------------
    void dessine_bargraph_pupitre(int _numero_pupitre) {                                                                                            //  c'est un dessin : le numero de pupitte démarre à 0
        noStroke();       
        float course_curseur = (curseur_down-curseur_up)/20F;        
        largeur_pixel        = largeur_tuile/5/10;
        hauteur_pixel        = course_curseur/12;
        colorMode(HSB,1000,100,100);
        if (horloge[_numero_pupitre+1]) {                                                                                                           //  on ajoute 1 car ce n'est pas un dessin 
            if (duree_restante[_numero_pupitre+1] > 0) {                                                                                            //  on ajoute 1 car ce n'est pas un dessin 
                for (int i = int(1.05*(curseur_down-curseur_up)*(127-duree_restante[_numero_pupitre+1])); i < 333; i++) {                           //  le bargraph suit exactement la hauteur du curseur
                    fill(500, 100, 100);                                                                                                            //  couleur AQUA en HSB
                    rect(x_pupitre+(2*_numero_pupitre+3*largeur_tuile/5+.55*largeur_pixel)*zoom_p,
                         y_pupitre+(2.5*i/333+1.5)*zoom_p,
                         (largeur_tuile/5-2.1*largeur_pixel)*zoom_p,
                         2);
                }
            } else {
                if (duree_restante[_numero_pupitre+1] != 0) {
                    for (int i = int(1.05*(curseur_down-curseur_up)*(127-hauteur_curseur[_numero_pupitre+1])); i < 333; i++) {                      //  le bargraph suit exactement la hauteur du curseur
                        fill(500, 100, 100);                                                                                                        //  couleur AQUA en HSB
                        rect(x_pupitre+(2*_numero_pupitre+3*largeur_tuile/5+.55*largeur_pixel)*zoom_p,
                             y_pupitre+(2.5*i/333+1.5)*zoom_p,
                             (largeur_tuile/5-2.1*largeur_pixel)*zoom_p,
                             2);
                    }
                }
            }
        } else {
            for (int i = int(1.05*(curseur_down-curseur_up)*(127-vitesse[_numero_pupitre+1])); i < 333; i++) {                                      //  le bargraph suit exactement la vitesse du train
                fill(i, 100, 100);                                                                                                                  //  la couleur change 333 fois de vert, puis orange et rouge
                rect(x_pupitre+(2*_numero_pupitre+3*largeur_tuile/5+.55*largeur_pixel)*zoom_p,
                     y_pupitre+(2.5*i/333+1.5)*zoom_p,
                     (largeur_tuile/5-2.1*largeur_pixel)*zoom_p,
                     2);
            }
        }
        colorMode(RGB,255,255,255);
    }
    //---------------------------------- dessine_texte_pupitre() ---------------------------------------------------------
    void dessine_texte_pupitre(int _numero_pupitre) {                                                                                               //  ce numero_pupitre démarre à 1               
        for (int j = 0; j < 29; j++) {
            texte = str(j+100);
            texte = "F"+texte.substring(1,3);
            bouton = new Bouton1(_numero_pupitre+1).copy();                                                                                         //  on ajoute 1 car ce n'est pas un dessin 
            textFont(fontMessage);
            fill(NOIR);
            textAlign(CENTER, CENTER);
            textSize(0.08*zoom_p);
            bouton.dessine_bouton(x_pupitre,
                                  y_pupitre,
                                  (_numero_pupitre-1)*2F*largeur_tuile, hauteur_tuile/5F+hauteur_tuile*j/6.5F,
                                  largeur_tuile, hauteur_tuile,
                                  hauteur_tuile/5.2F,
                                  zoom_p,
                                  zoom_p,
                                  texte,
                                  presse[_numero_pupitre][j]);
        }
    }
    //---------------------------------- dessine_cabs_pupitre() ---------------------------------------------------------
    void dessine_cabs_pupitre(int _numero_pupitre, int _feu) {                                                                                      //  c'est un dessin : le numero de pupitte démarre à 0               
            cabs[_numero_pupitre+1] = new CabSignal(x_pupitre+(2F*_numero_pupitre+0.26F*largeur_tuile)*zoom_p, y_pupitre+0.22F*hauteur_tuile*zoom_p);
            cabs[_numero_pupitre+1].dessine_signal(_feu);
    }
    //---------------------------------- dessine_digits_vitesse() ---------------------------------------------------------
    void dessine_digits_vitesse(int _numero_pupitre) {                                                                                              //  c'est un dessin : le numero de pupitte démarre à 0        
        textFont(fontUnits);
        fill(AQUA);
        textAlign(RIGHT, BOTTOM);
        textSize(0.17*zoom_p);
        text(vitesse[_numero_pupitre+1],
             x_pupitre+(_numero_pupitre*2F*largeur_tuile+43F*largeur_pixel)*zoom_p,
             y_pupitre+(hauteur_tuile+18F*hauteur_pixel)*zoom_p);
    }
    //---------------------------------- dessine_digits_consigne() ---------------------------------------------------------
    void dessine_digits_consigne(int _numero_pupitre) {    
        textFont(fontUnits);
        fill(BLANC);
        textAlign(RIGHT, BOTTOM);
        textSize(0.17*zoom_p);
        text(consigne_train[_numero_pupitre+1],
             x_pupitre+(_numero_pupitre*2F*largeur_tuile+43F*largeur_pixel)*zoom_p,
             y_pupitre+(hauteur_tuile-10F*hauteur_pixel)*zoom_p);
    }    
    //---------------------------------- dessine_digits_horloge() ---------------------------------------------------------
    void dessine_digits_horloge(int _numero_pupitre) {    
        if (itineraire != null) {
            textFont(fontUnits);
            fill(AQUA);
            textAlign(RIGHT, BOTTOM);
            textSize(0.17*zoom_p);
            if (duree_restante[_numero_pupitre+1] > 0) {
                text(max_duree[_numero_pupitre+1],
                     x_pupitre+(_numero_pupitre*2F*largeur_tuile+43F*largeur_pixel)*zoom_p,
                     y_pupitre+(hauteur_tuile+18F*hauteur_pixel)*zoom_p);
            } else {
                text(itineraire.duree_arret,
                     x_pupitre+(_numero_pupitre*2F*largeur_tuile+43F*largeur_pixel)*zoom_p,
                     y_pupitre+(hauteur_tuile+18F*hauteur_pixel)*zoom_p);
            }
        }
    }    
    //----------------------------- deplace_pupitre() --------------------------------------------------
    void deplace_pupitre() {
        if (deplacement_pupitre) {                       
            x_mouse_p = mouseX;
            y_mouse_p = mouseY;
                for (int c1 = 0; c1 < nb_pupitres; c1++) {
                    x_pupitre = int(mouseX-bordure_x);
                    y_pupitre = int(mouseY-bordure_y);
                    image(fond_pupitre,
                          mouseX-bordure_x+2*c1*largeur_tuile*zoom_p,
                          mouseY-bordure_y+l_max_p/5*hauteur_tuile*zoom_p,
                          2*largeur_tuile*zoom_p,
                          5*hauteur_tuile*zoom_p);
                }    
            if (!mousePressed) {
                x_pupitre           = x_mouse_p-bordure_x;
                y_pupitre           = y_mouse_p-bordure_y;
                selectionne         = false;
                deplacement_pupitre = false;
            }
        }
    }    
    //------------------------------ test_pupitres() --------------------------------------
    void test_pupitres() {
        x_mouse = mouseX;
        y_mouse = mouseY;
        dans_les_pupitres = false;
        if (affiche_pupitre) {
            if ((x_mouse >= x_pupitre && x_mouse <= x_pupitre+nb_pupitres*2*largeur_tuile*zoom_p)
             && (y_mouse >= y_pupitre && y_mouse <= y_pupitre+5*hauteur_tuile*zoom_p)) {
                dans_les_pupitres = true; 
            }
        }
    }    
    //------------------------------ test_pupitre() --------------------------------------
    void test_pupitre() {
        x_mouse = mouseX;
        y_mouse = mouseY;
        if (dans_les_pupitres) {
            for (int numero_pupitre = 1; numero_pupitre < nb_pupitres+1; numero_pupitre++) {                                                        //  il y a forcément au moins un pupitre à ce stade
                if ((x_mouse >= x_pupitre && x_mouse <= x_pupitre+(numero_pupitre)*2*largeur_tuile*zoom_p)
                 && (y_mouse >= y_pupitre && y_mouse <= y_pupitre+5*hauteur_tuile*zoom_p)) {
                    pupitre.dans_pupitre(numero_pupitre);
                    break;
                }
            }
        }
    }    
    //------------------------------ test_bouton() --------------------------------------
    void test_bouton() {
        x_mouse = mouseX;
        y_mouse = mouseY;
        if (mousePressed) {
            compte++;
            for (int i = 0; i < nb_pupitres; i++) {
                for (int j = 0; j < 29; j++) {
                    float x_bg_cg = x_pupitre+i*2F*zoom_p+1.1F*largeur_tuile*zoom_p;    //  bouton gauche  colonne gauche
                    float x_bd_cg = x_bg_cg+18F*largeur_tuile*zoom_p/50F;               //  bouton droit   colonne gauche
                    float x_bg_cd = x_pupitre+i*2F*zoom_p+1.55F*largeur_tuile*zoom_p;   //  bouton gauche  colonne droite
                    float x_bd_cd = x_bg_cd+18F*largeur_tuile*zoom_p/50F;               //  bouton droit   colonne droite
                    
                    float y_bh_cg = y_pupitre+(1/5F+j/6.5F)*hauteur_tuile*zoom_p;       //  bouton haut    colonne gauche
                    float y_bb_cg = y_bh_cg+hauteur_bouton*zoom_p;                      //  bouton bas     colonne gauche
                    float y_bh_cd = y_pupitre+(1/5F+j/6.5F)*hauteur_tuile*zoom_p;       //  bouton haut    colonne droite
                    float y_bb_cd = y_bh_cd+hauteur_bouton*zoom_p;                      //  bouton bas     colonne droite
                    if (compte == 1) {
                        switch (j%2) {
                            case 0:
                                if ((x_mouse >= x_bg_cg && x_mouse <= x_bd_cg) && (y_mouse >= y_bh_cg && y_mouse <= y_bb_cg)) {
                                    presse[i+1][j] = !presse[i+1][j];
                                }
                                break;
                            case 1:
                                if ((x_mouse >= x_bg_cd && x_mouse <= x_bd_cd) && (y_mouse >= y_bh_cd && y_mouse <= y_bb_cd)) {
                                    presse[i+1][j] = !presse[i+1][j];
                                }
                                break;
                        }
                    }
                }
            }
        } else {
            compte = 0;
        }
    }
    //---------------------------- pave_dans_pupitre() -----------------------------------
    void dans_pupitre(int _numero_pupitre) {                                                                                                        //  _numero_pupitre démarre à 1
        box_p[_numero_pupitre] = 0;
        //                    ┌────┬────┐
        //                    │  0 │    │
        //                    ├────┤    │
        //                    │    │    │
        //                    │    │    │       
        //                    │  1 │  3 │
        //                    │    │    │   
        //                    │    │    │
        //                    ├────┤    │
        //                    │  2 │    │
        //                    └────┴────┘    

        c_mouse = (x_mouse-bordure_x)/MAILLE/zoom_x;
        l_mouse = (y_mouse-bordure_y)/MAILLE/zoom_y;
        
        int sub_x = int((x_mouse-x_mouse_p)/largeur_tuile/zoom_p);
        if (sub_x < 2*nb_pupitres) {
            int sub_y = int((y_mouse-y_mouse_p)/hauteur_tuile/zoom_p);
            
            if ((sub_x)%2 == 0 && (sub_y)%5 == 0) box_p[_numero_pupitre] = 0;
            if ((sub_x)%2 == 1 && (sub_y)%5 == 0) box_p[_numero_pupitre] = 3;
            if ((sub_x)%2 == 0 && (sub_y)%5 == 1) box_p[_numero_pupitre] = 1;
            if ((sub_x)%2 == 1 && (sub_y)%5 == 1) box_p[_numero_pupitre] = 3;
            if ((sub_x)%2 == 0 && (sub_y)%5 == 2) box_p[_numero_pupitre] = 1;
            if ((sub_x)%2 == 1 && (sub_y)%5 == 2) box_p[_numero_pupitre] = 3;
            if ((sub_x)%2 == 0 && (sub_y)%5 == 3) box_p[_numero_pupitre] = 1;
            if ((sub_x)%2 == 1 && (sub_y)%5 == 3) box_p[_numero_pupitre] = 3;
            if ((sub_x)%2 == 0 && (sub_y)%5 == 4) box_p[_numero_pupitre] = 2;
            if ((sub_x)%2 == 1 && (sub_y)%5 == 4) box_p[_numero_pupitre] = 3;
            numero_pupitre = sub_x/2;                                                                                                               //  dit dans quel pupitre on est. on démarre à 0
            //------------------------------------ case train ----------------------------
            if (mousePressed && box_p[_numero_pupitre] == 2) {
                if (affiche_trains) {
                    //train_pupitre(_numero_pupitre);
                    int numero_pupitre = 1;
                    for (int i = 0; i < liste_trains.size(); i++) {
                        if (liste_trains.get(i) != 0) {
                            if (numero_pupitre == _numero_pupitre) {
                                choix_train = i+1;
                                break;
                            }
                            numero_pupitre++;
                        }
                    }
                }
            }
            if (mousePressed && box_p[_numero_pupitre]  == 0) {
                deplacement_pupitre = true;
                selectionne = true;
                previous_c_p = c_mouse+MAILLE*zoom_p;
                previous_l_p = l_mouse+MAILLE*zoom_p;
            }
        }
    }
}
//---------------------------------- train_pupitre() --------------------------------
void train_pupitre(int _numero_train) {
    if (_numero_train <= 0) {
        num_train_pupitre = 0;
    } else {
        num_train_pupitre = 0;
        for (int i = 0; i < liste_trains.size(); i++) {
            if (liste_trains.get(i) != 0) {
                if (i+1 == _numero_train) {
                    num_train_pupitre = liste_trains.get(i);
                    break;
                }
            }
        }
    }
}
