//-------------------- sélection des fichiers via Java --------------------------
import java.io.*; 
FilenameFilter tsvFilter = new FilenameFilter() {
    public boolean accept(File dir, String name) {
        return name.toLowerCase().endsWith(".tsv");
    }
};
//------------------------ fileSelected() ------------------------------
void fileSelected(File selection) {
    if (selection != null) {
        for (int c = 0; c < c_max; c++) {
            for (int l = 0; l < 2*l_max; l++) {
                tco.paves[c][l] = null;
            }
        }
        file_selected = selection.getAbsolutePath();
        //------------------------ Chargement des tables ---------------------------------------
        charge_table_TCO();
        charge_table_Materiel();
    }
}
//---------------------- java : JOptionPlane -------------------------
import static javax.swing.JOptionPane.*;                                                                                                           //  utilise pour les questions

//////////////////////////////////////////// setup() /////////////////////////////////////////////////////////////////////////
void setup() {
    size(1366, 768, P2D);
    colorMode(RGB, 255, 255, 255);
    imageMode(CORNER);
    noStroke();
    tco            = new TCO();   
    palette        = new Palette();
    vehicule       = new Vehicule();
    zone           = new Zone();
    point          = new Point();
    pupitre        = new Pupitre();
    zoom_change    = 2;
    //------------------------ Creation des tables ---------------------------------------
    creation_table_TCO();
    creation_table_Materiel();
    //------------------------ Selection du fichier au demarrage ----------------------
    selectInput("Selectionnez un fichier pour determiner le repertoire de demarrage : ", "fileSelected");
    //------------------------ Préparation des itinéraires ---------------------------------------
    for (int index = 0; index < INDEX_MAX; index++) {
        premier[index] = new PVector();
    }    
    //------------------------ Fontes pour les textes ---------------------    
    fontMessage = createFont("data/Icones/ComicHelvetic_Light.otf", 10);
    fontUnits   = createFont("data/Icones/DSEG7Classic-BoldItalic.ttf", 10);
    //------------------------ Images constituantes ---------------------------
    charge_images();    
    one_shot            = true;
    deplacement_pupitre = false;
    width_precedent     = width;
}
/////////////////////////////////// draw() ///////////////////////////////////////////////////////////
void draw() {
    if (tables_construites && !supp_en_cours) {
        newTimeFeux=millis();
        if ((newTimeFeux - oldTimeFeux) > 428) {                                                                                                   //  pour clignotement (428 = 70 Hz)
            cliFeux     = !cliFeux;
            oldTimeFeux = newTimeFeux;
        }
        if (!deplacement_pupitre) {
            if (one_shot || width != width_precedent || affiche_numero_zone) {
                one_shot = false;
                fill(FOND);
                rect(0, 0, width, height);                                                                                                         //  efface le TCO
                image(fond_ecran, 0, 0, width, height);
                ecran      = createImage(width, height, RGB);                                                                                      //  ce sera l'image de l'écran, avec les rails
                tco.dessine_tco_debut();                                                                                                           //  prepare l'image du TCO qui comprendra des details que l'on ne calculera plus
                tco.dessine_tco_debut();                                                                                                           //  une deuxième fois est nécessaire pour le calcul des retraits
                tco.maj_signaux();                                                                                                                 //  mise à jour des signaux pour le premier ecran
                tco.dessine_feux_tco();                                                                                                            //  dessine tous les feux
                width_precedent = width;
                //------------ calcule l'image du fond d'ecran ---------------------
                ecran.loadPixels();                                                                                                                //  prépare la variable écran
                loadPixels();                                                                                                                      //  charge l'écran complet dans la variable Pixels()
                for (int i = 0; i < pixels.length; i++) {
                    ecran.pixels[i] = pixels[i];                                                                                                   //  prépare la copie tous les pixels de l'écran dans la variable écran                                                                                               
                }
                ecran.updatePixels();                                                                                                              //  met à jours la variable écran. A noter que cette variable écran n'a pas de trains
                texte_affiche = ".";                                                                                                               //  mise à vide du texte affichée
                couleur_affichee = BLANC;                                                                                                          //  fond blanc pour le texte
                for (Itineraire iti0 : tous_iti) {
                    iti0.calcule_points_iti();
                }
            } else {
                image(ecran, 0, 0, width, height);                                                                                                 //  on affiche tout le réseau. C'est la seule chose qu'on fasse à chaque tour. C'est très rapide
            }
        } else {                                                                                                                                   //  quand on deplace le pupitre, on bloque tout l'affichage (on le fait au debut et c'est memorise dans la sauvegarde)
            image(ecran, 0, 0, width, height);                                                                                                     //  redessine tout le réseau avant d'afficher le pupitre
            pupitre.deplace_pupitre();                                                                                                             //  dessine le pupitre quand il est en train de se deplacer
            one_shot         = true;                                                                                                               //  pour ne plus afficher le réseau du début, ce qui est long
        }
        dessine_tous_iti();                                                                                                                        //  dessine tous les itinéraires (couleur BLANC, VERT et ROUGE)
        dessine_itineraire_tempo();                                                                                                                //  affichage d'un des itinéraires trouvés (couleur SABLE)
        tco.dessine_tco();                                                                                                                         //  met à jour la position des aiguilles et les dessine        
        tco.maj_signaux();                                                                                                                         //  mise à jour des signaux pour le premier ecran
        tco.dessine_feux_tco();                                                                                                                    //  dessine tous les feux
        pupitre.gere_trains();                                                                                                                     //  gère tous les trains (partie gestion fixe et les transferts)
        pupitre.dessine_pupitres();
        pupitre.dessine_trains();                                                                                                                  //  dessine les trains en mouvement (occupations, vitesse)
        if (affiche_trains) {                                                                                                                      //  affiche le panneau de composition des trains
            pupitre.affiche_train();                                                                                                               //  affiche la composition du train choisi
        } else {
            menu();                                                                                                                                //  affiche le menu
            if (!texte_affiche.equals(".")) {                                                                                                      //  affiche le texte des messages. On peut avoir un texte sans le menu
                affiche_texte(texte_affiche, couleur_affichee);
            }
            if (aide) {                                                                                                                            //  affiche les aides 
                image(texte_aide, 100, 10, largeur_texte, hauteur_texte);
            }
        }
    }
}
